#include <stdio.h>
#include <avr/io.h>
#include <util/delay.h>

#include "io.h"
#include "card_io.h"

#define	NB_CHIFFRES 3
int compteur[NB_CHIFFRES]={0,0,0};
long ms=0;

void effacer(void){
int i;
for(i=1;i<MAX_LED;i++) LED_set(leds[i]);
}

int zero[]={0,1,2,3,4,5,-1};
int un[]={1,2,-1};
int deux[]={0,1,3,4,6,-1};
int trois[]={0,1,2,3,6,-1};
int quatre[]={1,2,5,6,-1};
int cing[]={0,2,3,5,6,-1};
int six[]={0,2,3,4,5,6,-1};
int sept[]={0,1,2,-1};
int huit[]={0,1,2,3,4,5,6,-1};
int neuf[]={0,1,2,3,5,6,-1};

int *chiffres[]={zero,un,deux,trois,quatre,cing,six,sept,huit,neuf};

void afficher(int c){
if(c<0 || c>9) return;
int i=0;
while(chiffres[c][i]>=0){
  LED_unset(leds[chiffres[c][i]+1]);
  i++;
  }
}

#define REFRESH_DISP
#define COUNTER

#ifdef COUNTER
#define	TIMEOUT	100
uint32_t timeout=TIMEOUT;
#endif

int main(void)
{
outputs_init(OUTPUT_PORTB,OUTPUT_PORTC,OUTPUT_PORTD);
{
  int i;
  for(i=0;i<MAX_DISPLAY;i++) DISP_set(displays[i]);
  for(i=1;i<MAX_LED;i++) LED_set(leds[i]);
  }
#ifdef TEST_DISP
int i,j;
for(j=0;j<MAX_DISPLAY;j++){
  DISP_unset(displays[j]);
  for(i=1;i<MAX_LED;i++){
    LED_toggle(leds[i]);
    _delay_ms(500);
    LED_toggle(leds[i]);
    }
  DISP_set(displays[j]);
  }
#endif
while(1){
#ifdef TEST_BLINK
  LED_toggle(leds[0]);
  _delay_ms(500);
#endif
#ifdef REFRESH_DISP
  int i;
  for(i=0;i<MAX_DISPLAY;i++){
    DISP_unset(displays[i]);
    afficher(compteur[i]);
    _delay_ms(1);
    effacer();
    DISP_set(displays[i]);
    }
#endif
#ifdef COUNTER
  if(timeout>0) timeout--;
  else{
    timeout=TIMEOUT;
    int i;
    for(i=NB_CHIFFRES-1;i>=0;i--){
      if(compteur[i]<9){ compteur[i]++; break; }
      else compteur[i]=0;
      }
    }
#endif
  }
return 0;
}

